/**
 * RendSite 2008
 * Copyright Erich P Gatejen 2008, 2009 
 */
package rendsite;

import things.common.ThingsConstants;

/**
 * General constants.
 * @author  erich
 * <i>Version History</i>
 * <pre>
 * 10NOV09 - EPG - First package release.
 * </pre>
 */
public interface Constants extends ThingsConstants {
	
	// =============================================================================
	// DEFAULTS
	
	public final static String RENDSITE_NOTICE = "Generated by RendSite 2009";
	
	public final static String ERRORED = "ERRORED";
	public final static String UNKNOWN = "UNKNOWN";

	
	// =============================================================================
	// CONSTANT CONFIG
	
	/**
	 * Any file with this as a prefix is considered a MetaFile.
	 */
	public final static String METAFILE_PREFIX = "..";
	
	/**
	 * If this is the suffix of a metafile, it is a local meta.
	 */
	public final static String METAFILE_LOCAL_SUFFIX = "local";
	

	// =============================================================================
	// NAMES	
	
	public final static String NAME_METAFILE = "metafile";
	public final static String NAME_METAFILE_LOCAL = "metafile.local";
	public final static String NAME_FRAME_LOCATION = "location";
	public final static String NAME_BASE_FRAME_LOCATION = "location.base";
	public final static String NAME_DIRECTORY = "directory";	
	public final static String NAME_DIRECTORY_PANIC = "directory.panic";	
	public final static String NAME_DIRECTORY_FAULT = "directory.fault";	
	public final static String NAME_DIRECTORY_ERROR = "directory.error";	
	public final static String NAME_DIRECTORY_SOURCE = "directory.source";	
	public final static String NAME_FILE = "file";	
	public final static String NAME_FILE_SOURCE = "file.source";	
	public final static String NAME_FILE_RENDERED = "file.rendered";	
	public final static String NAME_FILE_EXCPECTED = "file.expected";	
	public final static String NAME_DIRECTORY_DESTINATION = "directory.destination";
	public final static String NAME_FILE_DESTINATION = "file.destination";	
	public final static String NAME_FILE_PANIC = "directory.panic";	
	public final static String NAME_FILE_FAULT = "directory.fault";	
	public final static String NAME_FILE_ERROR = "directory.error";	
	public final static String NAME_RENDERER_NAME = "renderer.name";
	public final static String NAME_RENDERER_CLASS = "renderer.class";
	
	public final static String NAME_REASON = "reason";
	
	public final static String NAME_FILTER = "filter";
	public final static String NAME_FILTER_TYPE = "filter.type";
	
	public final static String NAME_ERROR = "error";	
	public final static String NAME_CATEGORY = "category";	
	public final static String NAME_CATEGORY_COMPLETE = "category.complete";	
	public final static String NAME_CATEGORY_COMPLETE_EXISTING = "category.complete.existing";	
	public final static String NAME_ERROR_NUMBER = "error.number";
	public final static String NAME_ERROR_NUMBER_ALLOWED = "error.number.allowed";
	
	public final static String NAME_FAULT_NUMBER = "fault.number";
	public final static String NAME_FAULT_NUMBER_ALLOWED = "fault.number.allowed";
	
	public final static String NAME_LOCALE = "locale";
	
	public final static String NAME_CLEAR_REASON = "clear.reason";			// A clear reason is given when the cause is obviously appropriate for the user logs.

	// Error management
	public final static String NAME_ERROR__ROOT_CAUSE = "error.cause.root";
	public final static String NAME_ERROR__BASE_CAUSE = "error.cause.base";
	public final static String NAME_ERROR__BASE_NUMERIC = "error.numeric.base";
	
}



